#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <phonon/mediaobject.h>
#include <widgetquran.h>

#include <QMainWindow>
#include <phonon/audiooutput.h>
#include <QTextCharFormat>
#include <QComboBox>
#include <QFontComboBox>
#include <QTreeWidgetItem>
namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
        Q_OBJECT
        
public:
        explicit MainWindow(QWidget *parent = 0);
        ~MainWindow();
protected:
        virtual void closeEvent(QCloseEvent *e);
signals:
        void mediaChanged(bool );
private slots:
        void openMedias();
        void themeIcons();
        void on_comboBox_activated(const QString &arg1);
        void mediaSetSource(const QString &arg1);
        void stateChanged(Phonon::State newstate, Phonon::State );
        void hasVideoChanged(bool bHasVideo);
        void updateTime();
        void playPause();
        void mediaBackward();
        void mediaForward();
        void mediaGoPos();
        //void on_actionPlayPause_triggered();
        void fileNew();
        bool load(const QString &f);
        bool maybeSave();
        void fileOpen();
        bool fileSave();
      bool  fileSessionSaveAs();
        bool fileSaveAs();
        void filePrint();
        void filePrintPreview();
void printPreview(QPrinter *printer);
        void filePrintPdf();
        void textColor();
        void textStyle(int styleIndex);
        void textFamily(const QString &f);
        void textBold();
        void textUnderline();
        void textItalic();
        void textAlign(QAction *a);
void addBokmark();
        void currentCharFormatChanged(const QTextCharFormat &format);
        void cursorPositionChanged();

        void clipboardDataChanged();

        void textSize(const QString &p);

        void setCurrentFileName(const QString &fileName);
        void on_actionOpen_triggered();


        void setTextQuran(const QString &txt);
      void setTextSymbole(const QString &txt);


        void on_textEdit_highlighted(const QString &arg1);

        void on_textEdit_anchorClicked(const QUrl &arg1);
void aboutThisProgram();
private:


        Ui::MainWindow *ui;
        widgetQuran *widQuran;
        QStringList soundFiles;
        int recentPos;
        QString fileName;
        void mergeFormatOnWordOrSelection(const QTextCharFormat &format);
        void fontChanged(const QFont &f);
        void colorChanged(const QColor &c);
        void alignmentChanged(Qt::Alignment a);

        Phonon::MediaObject m_MediaObject;
        Phonon::AudioOutput m_AudioOutput;
        QIcon m_playIcon;
        QIcon m_pauseIcon;
        QAction  *actionAlignLeft,
        *actionAlignCenter,
        *actionAlignRight,
        *actionAlignJustify;
        QComboBox *comboStyle ;
        QFontComboBox *comboFont ;
        QComboBox *comboSize ;

};

#endif // MAINWINDOW_H
