#include "widgetquran.h"
#include "ui_widgetquran.h"
#include <QTextCodec>
#include <QMessageBox>
#include <QSqlError>
#include <QSqlQuery>
#include <QDebug>
#include <QSqlRecord>
#include <QDir>
widgetQuran::widgetQuran(QWidget *parent) :
        QWidget(parent),
        ui(new Ui::widgetQuran)
{
        ui->setupUi(this);
        QDir appDir(QApplication::applicationDirPath());

        appDir.cdUp();
        m_appPath=  appDir.absolutePath()+"/share/"+QApplication::applicationName();
        ui->treeWidget->setColumnWidth(0,200);
        //ui->pushButtonInsert->setIcon(QIcon::fromTheme("edit-add",QIcon(":/images/edit-add")));
        ui->toolButtonGo->setIcon(QIcon::fromTheme("dialog-ok",QIcon(":/images/dialog-ok")));
        ui->toolButtonGoSearch->setIcon(QIcon::fromTheme("dialog-ok",QIcon(":/images/dialog-ok")));

        db = QSqlDatabase::addDatabase("QSQLITE");
        db.setDatabaseName(m_appPath+"/quran.db");

        // tableName = "quran";
        QString txt="no database";
        if(!db.open()){
                txt=db.lastError().text();
                QMessageBox::information(0,"",txt);

        }
}

widgetQuran::~widgetQuran()
{
        delete ui;

}

void widgetQuran::on_treeWidget_itemSelectionChanged()
{
        QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));

        QTreeWidgetItem *item=ui->treeWidget->currentItem();
        if(item){
                QString txt=item->text(0);
                QString sura=item->text(1);
                QString aya=item->text(2);
                QString htm=QString(trUtf8(" <span style=\" font-family:'Amiri Quran,Arial'; font-size:16pt; \">﴿ %1 ﴾ [%2 : %3]</span>"))
                                .arg(txt).arg(sura).arg(aya);
                //   ui->textEditQuran->setHtml( "<span style=\" font-family:'AGA Arabesque,Courier New,courier';\">\357\201\225</span></p>");


                ui->textEditQuran->setHtml(htm);
        }
}

void widgetQuran::on_treeWidget_itemActivated(QTreeWidgetItem *item, int /*column*/)
{
        QString txt=item->text(0);
        QString sura=item->text(1);
        QString aya=item->text(2);
        emit inserText(txt+"|"+sura+"|"+aya);
}


//-----------------------------قاغدة بيانات القرءان------------------------------------
void widgetQuran::dataSearchString(QTreeWidget *view,QString arg1)
{

        //-----------------------
        QString querytxt;

        querytxt=QString("SELECT* FROM quran WHERE nass_safy like '%%1%' ORDER BY id").arg(arg1);


        QSqlQuery query(querytxt,db);
        if(query.lastError().isValid()){
                qDebug()<<query.lastError();
                QMessageBox::information(0,"",query.lastError().text());
                return ;
        }
        //query.next();
        view->clear();
        while (query.next()) {
                int fieldId= query.record().indexOf("id");
                QString myid= query.value(fieldId).toString();
                int fieldTxt= query.record().indexOf("text");
                QString mytext = query.value(fieldTxt).toString();
                int fieldSura= query.record().indexOf("sura");
                QString mysura= query.value(fieldSura).toString();
                int fieldAya= query.record().indexOf("aya");
                QString myaya= query.value(fieldAya).toString();
                QTreeWidgetItem *item=new  QTreeWidgetItem(view);
                item->setText(0,mytext);
                item->setText(1,mysura);
                item->setText(2,myaya);
                item->setText(3,myid);
                //  QMessageBox::information(0,"",mytext);
                qDebug()<< myid+"-"+mysura+"-"+myaya+"-"+mytext;
                // query.next();
        }


}

void widgetQuran::getSuraMaximum(int sura)
{
        QString querytxt;

        querytxt=QString("SELECT* FROM quran WHERE sura=%1 ORDER BY id").arg(sura);
        //querytxt=QString("SELECT* FROM quran WHERE nass_safy like '%%1%' %2 nass_safy like'%%3%' ORDER BY id").arg(arg1).arg(orAnd).arg(arg2);


        QSqlQuery query(querytxt,db);
        if(query.lastError().isValid()){
                qDebug()<<query.lastError();
                QMessageBox::information(0,"",query.lastError().text());
                return ;
        }

        query.last();
        int fieldAya= query.record().indexOf("aya");
        int myAya= query.value(fieldAya).toInt();
        ui->spinBoxAya->setMaximum(myAya);
        qDebug()<<myAya;
}

void widgetQuran::goAyaSura()
{
        QString querytxt;
        int sura=ui->spinBoxSura->value();
        int aya=ui->spinBoxAya->value();
        // querytxt=QString("SELECT* FROM quran WHERE sura=%1 ORDER BY id").arg(sura);
        querytxt=QString("SELECT* FROM quran WHERE sura=%1  and aya=%3 ORDER BY id")
                        .arg(QString::number(sura)).arg(QString::number(aya));


        QSqlQuery query(querytxt,db);
        if(query.lastError().isValid()){
                qDebug()<<query.lastError();
                QMessageBox::information(0,"",query.lastError().text());
                return ;
        }
        ui->treeWidget->clear();
        query.last();

        int fieldTxt= query.record().indexOf("text");
        QString mytext = query.value(fieldTxt).toString();
        int fieldSura= query.record().indexOf("sura");
        QString mysura= query.value(fieldSura).toString();
        int fieldAya= query.record().indexOf("aya");
        QString myaya= query.value(fieldAya).toString();
        QTreeWidgetItem *item=new  QTreeWidgetItem(ui->treeWidget);
        item->setText(0,mytext);
        item->setText(1,mysura);
        item->setText(2,myaya);

        //  QMessageBox::information(0,"",mytext);
        qDebug()<< mysura+"-"+myaya+"-"+mytext;
        // query.next();
}

void widgetQuran::on_toolButtonGoSearch_clicked()
{
        QString txt=ui->lineEditSearch->text();
        if(txt.isEmpty())return;
        dataSearchString(ui->treeWidget,ui->lineEditSearch->text());

}

void widgetQuran::on_lineEditSearch_returnPressed()
{
        on_toolButtonGoSearch_clicked();
}

void widgetQuran::on_spinBoxSura_valueChanged(int arg1)
{
        getSuraMaximum(arg1);
}

void widgetQuran::on_toolButtonGo_clicked()
{
        goAyaSura();
}

void widgetQuran::on_listWidget_itemSelectionChanged()
{
        QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));

        QListWidgetItem *item=ui->listWidget->currentItem();
        if(item){
                QString txt=item->text();

                QString htm=QString(trUtf8("<span style=\" font-family:'AGA Arabesque';\">%1</span>")).arg(txt);

                //   ui->textEditQuran->setHtml( "<span style=\" font-family:'AGA Arabesque,Courier New,courier';\">\357\201\225</span></p>");


                ui->textEditQuran->setHtml(htm);
        }
}

void widgetQuran::on_listWidget_itemActivated(QListWidgetItem *item)
{
        if(item){
                QString txt=item->text();

                            emit inserSymbole(txt);
        }
       // emit inserText(ui->textEditQuran->toHtml());
}
